Index: LMDZ6/trunk/libf/phylmd/ecrad/radiation_aerosol_optics_data.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/ecrad/radiation_aerosol_optics_data.F90	(revision 4488)
+++ LMDZ6/trunk/libf/phylmd/ecrad/radiation_aerosol_optics_data.F90	(revision 4489)
@@ -57,4 +57,10 @@
      integer, allocatable, dimension(:) :: itype
 
+     ! Wavenumber (cm-1) upper and lower bounds of each spectral
+     ! interval, which if used in the RRTMG gas optics scheme should
+     ! match its band bounds
+     real(jprb), allocatable, dimension(:) :: wavenumber1_sw, wavenumber2_sw
+     real(jprb), allocatable, dimension(:) :: wavenumber1_lw, wavenumber2_lw
+
      ! Scattering properties are provided separately in the shortwave
      ! and longwave for hydrophobic and hydrophilic aerosols.
@@ -64,19 +70,27 @@
           &  ssa_sw_phobic,      & ! Single scattering albedo
           &  g_sw_phobic,        & ! Asymmetry factor
+!          &  ssa_g_sw_phobic,    & ! ssa*g
           &  mass_ext_lw_phobic, & ! Mass-extinction coefficient (m2 kg-1)
+!          &  mass_abs_lw_phobic, & ! Mass-absorption coefficient (m2 kg-1)
           &  ssa_lw_phobic,      & ! Single scattering albedo
           &  g_lw_phobic           ! Asymmetry factor
 
-     ! Hydrophilic aerosols are dimensioned (nband, nrh, n_type_philic):
+     ! Hydrophilic aerosols are dimensioned (nband,nrh,n_type_philic):
      real(jprb), allocatable, dimension(:,:,:) :: &
           &  mass_ext_sw_philic, & ! Mass-extinction coefficient (m2 kg-1)
           &  ssa_sw_philic,      & ! Single scattering albedo
           &  g_sw_philic,        & ! Asymmetry factor
+ !         &  ssa_g_sw_philic,    & ! ssa*g
           &  mass_ext_lw_philic, & ! Mass-extinction coefficient (m2 kg-1)
+ !         &  mass_abs_lw_philic, & ! Mass-absorption coefficient (m2 kg-1)
           &  ssa_lw_philic,      & ! Single scattering albedo
           &  g_lw_philic           ! Asymmetry factor
 
-     ! Scattering properties at selected wavelengths
-     ! (n_mono_wl,n_type_phobic/philic)
+     ! Wavelengths at which monochromatic properties are stored,
+     ! dimensioned (n_mono_wl), units metres
+     real(jprb), allocatable :: wavelength_mono(:)
+
+     ! Scattering properties at selected monochromatic wavelengths
+     ! (n_mono_wl,n_type_phobic)
      real(jprb), allocatable, dimension(:,:) :: &
           &  mass_ext_mono_phobic, & ! Mass-extinction coefficient (m2 kg-1)
@@ -84,4 +98,5 @@
           &  g_mono_phobic,        & ! Asymmetry factor
           &  lidar_ratio_mono_phobic ! Lidar Ratio
+     ! ...hydrophilic aerosols dimensioned (n_mono_wl,nrh,n_type_philic):
      real(jprb), allocatable, dimension(:,:,:) :: &
           &  mass_ext_mono_philic, & ! Mass-extinction coefficient (m2 kg-1)
@@ -104,8 +119,9 @@
      ! The number of hydrophobic and hydrophilic types read from the
      ! aerosol optics file
-     integer :: n_type_phobic, n_type_philic
+     integer :: n_type_phobic = 0
+     integer :: n_type_philic = 0
 
      ! Number of relative humidity bins
-     integer :: nrh
+     integer :: nrh = 0
 
      ! Number of longwave and shortwave bands of the data in the file,
@@ -121,4 +137,7 @@
    contains
      procedure :: setup => setup_aerosol_optics
+     procedure :: save  => save_aerosol_optics
+     procedure :: allocate
+     procedure :: initialize_types
      procedure :: set_hydrophobic_type
      procedure :: set_hydrophilic_type
@@ -135,5 +154,5 @@
   !---------------------------------------------------------------------
   ! Setup aerosol optics coefficients by reading them from a file
-  subroutine setup_aerosol_optics(this, file_name, ntype, iverbose)
+  subroutine setup_aerosol_optics(this, file_name, iverbose)
 
     use yomhook,              only : lhook, dr_hook
@@ -143,10 +162,12 @@
     class(aerosol_optics_type), intent(inout) :: this
     character(len=*), intent(in)              :: file_name
-    integer, intent(in)                       :: ntype
     integer, intent(in), optional             :: iverbose
 
     ! The NetCDF file containing the aerosol optics data
     type(netcdf_file)  :: file
+
+    real(jprb), allocatable :: wavelength_tmp(:)
     integer            :: iverb
+
     real(jprb)         :: hook_handle
 
@@ -168,4 +189,10 @@
       this%use_hydrophilic = .false.
     end if
+
+    ! Read the wavenumber bounds
+    call file%get('wavenumber1_sw', this%wavenumber1_sw)
+    call file%get('wavenumber2_sw', this%wavenumber2_sw)
+    call file%get('wavenumber1_lw', this%wavenumber1_lw)
+    call file%get('wavenumber2_lw', this%wavenumber2_lw)
 
     ! Read the raw scattering data
@@ -180,4 +207,8 @@
          &                         this%description_phobic_str)
 
+    ! Precompute ssa*g for the shortwave and mass-absorption for the
+    ! longwave - TBD FIX
+    !allocate(this%ssa_g_sw_phobic(...
+
     if (this%use_hydrophilic) then
       call file%get('mass_ext_sw_hydrophilic', this%mass_ext_sw_philic)
@@ -194,8 +225,33 @@
     end if
 
-    ! Read the raw scattering data at selected wavelengths if
-    ! available in the input file
+    ! Read the monochromatic scattering data at selected wavelengths
+    ! if available in the input file
     if (file%exists('mass_ext_mono_hydrophobic')) then
       this%use_monochromatic = .true.
+
+      if (allocated(this%wavelength_mono)) then
+        ! User has provided required monochromatic wavelengths, which
+        ! must match those in the file (in the more recent "general"
+        ! aerosol optics, interpolation provides optical properties at
+        ! the requested wavelengths)
+        call file%get('wavelength_mono', wavelength_tmp)
+        if (size(wavelength_tmp) /= size(this%wavelength_mono)) then
+          write(nulerr,'(a,i0,a,i0,a)') '*** Error: ', size(this%wavelength_mono), &
+               &  ' monochromatic wavelengths requested but ', &
+               &  size(wavelength_tmp), ' in file'
+          call radiation_abort('Radiation configuration error')
+        end if
+        if (any(abs(this%wavelength_mono-wavelength_tmp) &
+               &  / this%wavelength_mono > 0.01_jprb)) then
+          write(nulerr,'(a,a)') '*** Error: requested monochromatic wavelengths', &
+               &  'must all be within 1% of values in file'
+          call radiation_abort('Radiation configuration error')
+        end if
+      else
+        ! User has not provided required wavelengths, so we save the
+        ! monochromatic wavelengths in the file
+        call file%get('wavelength_mono', this%wavelength_mono)
+      end if
+
       call file%get('mass_ext_mono_hydrophobic', this%mass_ext_mono_phobic)
       call file%get('ssa_mono_hydrophobic',      this%ssa_mono_phobic)
@@ -233,14 +289,14 @@
         write(nulerr,'(a,a)') '*** Error: mass extinction for hydrophilic and hydrophobic ', &
              &                'aerosol have different numbers of longwave bands'
-        call radiation_abort()
+        call radiation_abort('Radiation configuration error')
       end if
       if (size(this%mass_ext_sw_philic,1) /= this%n_bands_sw) then
         write(nulerr,'(a,a)') '*** Error: mass extinction for hydrophilic and hydrophobic ', &
              &                'aerosol have different numbers of shortwave bands'
-        call radiation_abort()
+        call radiation_abort('Radiation configuration error')
       end if
       if (size(this%rh_lower) /= this%nrh) then
         write(nulerr,'(a)') '*** Error: size(relative_humidity1) /= size(mass_ext_sw_hydrophilic,2)'
-        call radiation_abort()
+        call radiation_abort('Radiation configuration error')
       end if
 
@@ -250,4 +306,16 @@
     end if
 
+    if (lhook) call dr_hook('radiation_aerosol_optics_data:setup',1,hook_handle)
+
+  end subroutine setup_aerosol_optics
+
+
+  !---------------------------------------------------------------------
+  ! Initialize the arrays describing the user's aerosol types
+  subroutine initialize_types(this, ntype)
+
+    class(aerosol_optics_type), intent(inout) :: this
+    integer,                    intent(in)    :: ntype
+    
     ! Allocate memory for mapping arrays
     this%ntype = ntype
@@ -258,7 +326,174 @@
     this%itype  = 0
 
-    if (lhook) call dr_hook('radiation_aerosol_optics_data:setup',1,hook_handle)
-
-  end subroutine setup_aerosol_optics
+  end subroutine initialize_types
+
+  !---------------------------------------------------------------------
+  ! Allocate arrays for aerosol optics data type
+  subroutine allocate(this, n_type_phobic, n_type_philic, nrh, &
+       &              n_bands_lw, n_bands_sw, n_mono_wl)
+
+    use yomhook,     only : lhook, dr_hook
+
+    class(aerosol_optics_type), intent(inout) :: this
+    integer, intent(in) :: n_type_phobic, n_type_philic, nrh
+    integer, intent(in) :: n_bands_lw, n_bands_sw, n_mono_wl
+
+    real(jprb) :: hook_handle
+
+    if (lhook) call dr_hook('radiation_aerosol_optics_data:allocate',0,hook_handle)
+
+    this%n_type_phobic = n_type_phobic
+    this%n_type_philic = n_type_philic
+    this%nrh           = nrh
+    this%n_bands_lw    = n_bands_lw
+    this%n_bands_sw    = n_bands_sw
+    this%n_mono_wl     = n_mono_wl
+
+    if (n_type_philic > 0) then
+      this%use_hydrophilic = .true.
+    else
+      this%use_hydrophilic = .false.
+    end if
+
+    if (n_bands_sw > 0) then
+      allocate(this%mass_ext_sw_phobic(n_bands_sw, n_type_phobic))
+      allocate(this%ssa_sw_phobic(n_bands_sw, n_type_phobic))
+      allocate(this%g_sw_phobic(n_bands_sw, n_type_phobic))
+    end if
+    if (n_bands_lw > 0) then
+      allocate(this%mass_ext_lw_phobic(n_bands_lw, n_type_phobic))
+      allocate(this%ssa_lw_phobic(n_bands_lw, n_type_phobic))
+      allocate(this%g_lw_phobic(n_bands_lw, n_type_phobic))
+    end if
+    if (n_mono_wl > 0) then
+      allocate(this%mass_ext_mono_phobic(n_mono_wl, n_type_phobic))
+      allocate(this%ssa_mono_phobic(n_mono_wl, n_type_phobic))
+      allocate(this%g_mono_phobic(n_mono_wl, n_type_phobic))
+      allocate(this%lidar_ratio_mono_phobic(n_mono_wl, n_type_phobic))
+    end if
+
+    if (n_type_philic > 0 .and. nrh > 0) then
+      if (n_bands_sw > 0) then
+        allocate(this%mass_ext_sw_philic(n_bands_sw, nrh, n_type_philic))
+        allocate(this%ssa_sw_philic(n_bands_sw, nrh, n_type_philic))
+        allocate(this%g_sw_philic(n_bands_sw, nrh, n_type_philic))
+      end if
+      if (n_bands_lw > 0) then
+        allocate(this%mass_ext_lw_philic(n_bands_lw, nrh, n_type_philic))
+        allocate(this%ssa_lw_philic(n_bands_lw, nrh, n_type_philic))
+        allocate(this%g_lw_philic(n_bands_lw, nrh, n_type_philic))
+      end if
+      if (n_mono_wl > 0) then
+        allocate(this%mass_ext_mono_philic(n_mono_wl, nrh, n_type_philic))
+        allocate(this%ssa_mono_philic(n_mono_wl, nrh, n_type_philic))
+        allocate(this%g_mono_philic(n_mono_wl, nrh, n_type_philic))
+        allocate(this%lidar_ratio_mono_philic(n_mono_wl, nrh, n_type_philic))
+      end if
+    end if
+
+    if (lhook) call dr_hook('radiation_aerosol_optics_data:allocate',1,hook_handle)
+
+  end subroutine allocate
+
+
+  !---------------------------------------------------------------------
+  subroutine save_aerosol_optics(this, file_name, iverbose)
+
+    use yomhook,     only : lhook, dr_hook
+    use easy_netcdf, only : netcdf_file
+
+    class(aerosol_optics_type), intent(inout) :: this
+    character(len=*),           intent(in)    :: file_name
+    integer,          optional, intent(in)    :: iverbose
+
+    ! Object for output NetCDF file
+    type(netcdf_file) :: out_file
+
+    real(jprb) :: hook_handle
+
+    if (lhook) call dr_hook('radiation_aerosol_optics_data:save',0,hook_handle)
+
+    ! Create the file
+    call out_file%create(trim(file_name), iverbose=iverbose)
+
+    ! Define dimensions
+    call out_file%define_dimension("band_lw", this%n_bands_lw)
+    call out_file%define_dimension("band_sw", this%n_bands_sw)
+    call out_file%define_dimension("hydrophilic", this%n_type_philic)
+    call out_file%define_dimension("hydrophobic", this%n_type_phobic)
+    call out_file%define_dimension("relative_humidity", this%nrh)
+    !if (this%use_monochromatic) then
+    !  call out_file%define_dimension("wavelength_mono", this%n_mono_wl)
+    !end if
+
+    ! Put global attributes
+    call out_file%put_global_attributes( &
+         &   title_str="Aerosol optical properties in the spectral intervals of the gas-optics scheme for ecRad", &
+         &   source_str="ecRad offline radiation model")
+    call out_file%put_global_attribute( &
+         &  "description_hydrophobic", this%description_phobic_str)
+    call out_file%put_global_attribute( &
+         &  "description_hydrophilic", this%description_philic_str)
+
+    ! Define variables
+    call out_file%define_variable("mass_ext_sw_hydrophobic", units_str="m2 kg-1", &
+         &  long_name="Shortwave mass-extinction coefficient of hydrophobic aerosols", &
+         &  dim2_name="hydrophobic", dim1_name="band_sw")
+    call out_file%define_variable("ssa_sw_hydrophobic", units_str="1", &
+         &  long_name="Shortwave single scattering albedo of hydrophobic aerosols", &
+         &  dim2_name="hydrophobic", dim1_name="band_sw")
+    call out_file%define_variable("asymmetry_sw_hydrophobic", units_str="1", &
+         &  long_name="Shortwave asymmetry factor of hydrophobic aerosols", &
+         &  dim2_name="hydrophobic", dim1_name="band_sw")
+
+    call out_file%define_variable("mass_ext_lw_hydrophobic", units_str="m2 kg-1", &
+         &  long_name="Longwave mass-extinction coefficient of hydrophobic aerosols", &
+         &  dim2_name="hydrophobic", dim1_name="band_lw")
+    call out_file%define_variable("ssa_lw_hydrophobic", units_str="1", &
+         &  long_name="Longwave single scattering albedo of hydrophobic aerosols", &
+         &  dim2_name="hydrophobic", dim1_name="band_lw")
+    call out_file%define_variable("asymmetry_lw_hydrophobic", units_str="1", &
+         &  long_name="Longwave asymmetry factor of hydrophobic aerosols", &
+         &  dim2_name="hydrophobic", dim1_name="band_lw")
+
+    call out_file%define_variable("mass_ext_sw_hydrophilic", units_str="m2 kg-1", &
+         &  long_name="Shortwave mass-extinction coefficient of hydrophilic aerosols", &
+         &  dim3_name="hydrophilic", dim2_name="relative_humidity", dim1_name="band_sw")
+    call out_file%define_variable("ssa_sw_hydrophilic", units_str="1", &
+         &  long_name="Shortwave single scattering albedo of hydrophilic aerosols", &
+         &  dim3_name="hydrophilic", dim2_name="relative_humidity", dim1_name="band_sw")
+    call out_file%define_variable("asymmetry_sw_hydrophilic", units_str="1", &
+         &  long_name="Shortwave asymmetry factor of hydrophilic aerosols", &
+         &  dim3_name="hydrophilic", dim2_name="relative_humidity", dim1_name="band_sw")
+
+    call out_file%define_variable("mass_ext_lw_hydrophilic", units_str="m2 kg-1", &
+         &  long_name="Longwave mass-extinction coefficient of hydrophilic aerosols", &
+         &  dim3_name="hydrophilic", dim2_name="relative_humidity", dim1_name="band_lw")
+    call out_file%define_variable("ssa_lw_hydrophilic", units_str="1", &
+         &  long_name="Longwave single scattering albedo of hydrophilic aerosols", &
+         &  dim3_name="hydrophilic", dim2_name="relative_humidity", dim1_name="band_lw")
+    call out_file%define_variable("asymmetry_lw_hydrophilic", units_str="1", &
+         &  long_name="Longwave asymmetry factor of hydrophilic aerosols", &
+         &  dim3_name="hydrophilic", dim2_name="relative_humidity", dim1_name="band_lw")
+
+    ! Write variables
+    call out_file%put("mass_ext_sw_hydrophobic", this%mass_ext_sw_phobic)
+    call out_file%put("ssa_sw_hydrophobic", this%ssa_sw_phobic)
+    call out_file%put("asymmetry_sw_hydrophobic", this%g_sw_phobic)
+    call out_file%put("mass_ext_lw_hydrophobic", this%mass_ext_lw_phobic)
+    call out_file%put("ssa_lw_hydrophobic", this%ssa_lw_phobic)
+    call out_file%put("asymmetry_lw_hydrophobic", this%g_lw_phobic)
+    call out_file%put("mass_ext_sw_hydrophilic", this%mass_ext_sw_philic)
+    call out_file%put("ssa_sw_hydrophilic", this%ssa_sw_philic)
+    call out_file%put("asymmetry_sw_hydrophilic", this%g_sw_philic)
+    call out_file%put("mass_ext_lw_hydrophilic", this%mass_ext_lw_philic)
+    call out_file%put("ssa_lw_hydrophilic", this%ssa_lw_philic)
+    call out_file%put("asymmetry_lw_hydrophilic", this%g_lw_philic)
+
+    call out_file%close()
+
+    if (lhook) call dr_hook('radiation_aerosol_optics_data:save',1,hook_handle)
+
+  end subroutine save_aerosol_optics
 
 
Index: LMDZ6/trunk/libf/phylmd/ecrad/radiation_aerosol_optics_description.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/ecrad/radiation_aerosol_optics_description.F90	(revision 4489)
+++ LMDZ6/trunk/libf/phylmd/ecrad/radiation_aerosol_optics_description.F90	(revision 4489)
@@ -0,0 +1,332 @@
+! radiation_aerosol_optics_description.F90 - Type to store aerosol optics metadata
+!
+! (C) Copyright 2022- ECMWF.
+!
+! This software is licensed under the terms of the Apache Licence Version 2.0
+! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
+!
+! In applying this licence, ECMWF does not waive the privileges and immunities
+! granted to it by virtue of its status as an intergovernmental organisation
+! nor does it submit to any jurisdiction.
+!
+! Author:  Robin Hogan
+! Email:   r.j.hogan@ecmwf.int
+!
+
+module radiation_aerosol_optics_description
+
+  use parkind1,      only : jprb
+
+  implicit none
+  public
+
+  !---------------------------------------------------------------------
+  ! This type holds the metadata from an aerosol optical property
+  ! file, enabling the user to request the index to the aerosol type
+  ! with particular properties.  Note that string information is held
+  ! in the form of 2D arrays of single characters, so comparison to
+  ! character strings requires the to_string helper function at the
+  ! end of this file.
+  type aerosol_optics_description_type
+
+    ! Two-character code describing the aerosol family, dimensioned
+    ! (2,naer), e.g.
+    !   SS: Sea salt
+    !   OM: Organic matter
+    !   SU: Sulfate
+    !   OB: Secondary organic biogenic
+    !   OA: Secondary organic anthropogenic
+    !   AM: Fine-mode ammonium sulfate
+    !   NI: Nitrate
+    !   DD: Desert dust
+    !   BC: Black carbon
+    character(len=1), allocatable :: code_phobic(:,:)
+    character(len=1), allocatable :: code_philic(:,:)
+
+    ! Size bin, typically 1-2 or 1-3 in order fine to coarse, or zero
+    ! if no division by size is used, dimensioned (naer)
+    integer, allocatable :: bin_phobic(:)
+    integer, allocatable :: bin_philic(:)
+
+    ! Character string characterizing the optical model, e.g. OPAC,
+    ! GACP, GLOMAP, Dubovik2002 etc.
+    character(len=1), allocatable :: optical_model_phobic(:,:)
+    character(len=1), allocatable :: optical_model_philic(:,:)
+
+    ! The user can call preferred_optical_model to specify that a
+    ! certain optical model for a certain aerosol family is to be
+    ! preferred when get_index is called
+    logical, allocatable :: is_preferred_phobic(:)
+    logical, allocatable :: is_preferred_philic(:)
+
+  contains
+    procedure :: read
+    procedure :: preferred_optical_model
+    procedure :: get_index
+
+  end type aerosol_optics_description_type
+
+contains
+
+  !---------------------------------------------------------------------
+  ! Read optical property file file_name into an
+  ! aerosol_optics_description_type object
+  subroutine read(this, file_name, iverbose)
+
+    use yomhook,              only : lhook, dr_hook
+    use easy_netcdf,          only : netcdf_file
+
+    class(aerosol_optics_description_type), intent(inout) :: this
+    character(len=*), intent(in)              :: file_name
+    integer, intent(in), optional             :: iverbose
+    
+    ! The NetCDF file containing the aerosol optics data
+    type(netcdf_file)  :: file
+
+    real(jprb)         :: hook_handle
+
+    if (lhook) call dr_hook('radiation_aerosol_optics_description:load',0,hook_handle)
+
+    ! Open the aerosol scattering file and configure the way it is
+    ! read
+    call file%open(trim(file_name), iverbose=iverbose)
+
+    ! Read metadata variables
+    call file%get('code_hydrophilic', this%code_philic)
+    call file%get('code_hydrophobic', this%code_phobic)
+    call file%get('bin_hydrophilic',  this%bin_philic)
+    call file%get('bin_hydrophobic',  this%bin_phobic)
+    call file%get('optical_model_hydrophilic', this%optical_model_philic)
+    call file%get('optical_model_hydrophobic', this%optical_model_phobic)
+
+    ! Allocate logical arrays of the appropriate size and set to FALSE
+    allocate(this%is_preferred_philic(size(this%bin_philic)))
+    allocate(this%is_preferred_phobic(size(this%bin_phobic)))
+    this%is_preferred_philic = .false.
+    this%is_preferred_phobic = .false.
+
+    call file%close()
+
+    if (lhook) call dr_hook('radiation_aerosol_optics_description:load',1,hook_handle)
+
+  end subroutine read
+
+  !---------------------------------------------------------------------
+  ! Specify the preferred optical model for a particular aerosol
+  ! family, e.g. "call
+  ! aer_desc%preferred_optical_model('DD','Woodward2001')" would mean
+  ! that subsequent calls to get_index in which the optical model is
+  ! not specified would return the Woodward model rather than the
+  ! first matching model in the file.  The check is only done on the
+  ! first len(optical_model_str) characters, so "Woodward" and
+  ! "Woodward2001" would both match the Woodward2001 model.
+  subroutine preferred_optical_model(this, code_str, optical_model_str)
+
+    use yomhook,              only : lhook, dr_hook
+
+    class(aerosol_optics_description_type), intent(inout) :: this
+    character(len=2), intent(in) :: code_str
+    character(len=*), intent(in) :: optical_model_str
+
+    ! Aerosol loop counter
+    integer :: ja
+
+    real(jprb)         :: hook_handle
+
+    if (lhook) call dr_hook('radiation_aerosol_optics_description:preferred_optical_model',0,hook_handle)
+
+    ! Loop over hydrophilic types
+    do ja = 1,size(this%bin_philic)
+      ! Check if we have a match
+      if (to_string(this%code_philic(:,ja)) == code_str &
+           &  .and. to_string(this%optical_model_philic(1:len(optical_model_str),ja)) &
+           &          == optical_model_str) then
+        this%is_preferred_philic(ja) = .true.
+      end if
+    end do
+    ! Repeat for the hydrophobic types
+    do ja = 1,size(this%bin_phobic)
+      if (to_string(this%code_phobic(:,ja)) == code_str &
+           &  .and. to_string(this%optical_model_phobic(1:len(optical_model_str),ja)) &
+           &          == optical_model_str) then
+        this%is_preferred_phobic(ja) = .true.
+      end if
+    end do
+
+    if (lhook) call dr_hook('radiation_aerosol_optics_description:preferred_optical_model',1,hook_handle)
+
+  end subroutine preferred_optical_model
+
+  !---------------------------------------------------------------------
+  ! Return the index to the aerosol optical properties corresponding
+  ! to the aerosol family in code_str (e.g. SS, DD etc), whether or
+  ! not the requested aerosol is hydrophilic in the logical
+  ! lhydrophilic, and optionally the size bin ibin and optical model
+  ! in optical_model_str. The return value may be used to populate the
+  ! radiation_config%i_aerosol_map vector, where a positive number is
+  ! a hydrophobic index, a negative number is a hydrophilic index and
+  ! zero indicates that the aerosol type was not found in the file.
+  ! This is a valid entry in i_aerosol_map meaning the aerosol is
+  ! ignored, but the calling routine to get_index might wish to throw
+  ! a warning or error. This routine works by assigning a score based
+  ! on the closeness of the match.
+  function get_index(this, code_str, lhydrophilic, ibin, optical_model_str)
+    
+    use yomhook,              only : lhook, dr_hook
+    use easy_netcdf,          only : netcdf_file
+    use radiation_io,         only : nulout
+
+    class(aerosol_optics_description_type), intent(in) :: this
+    character(len=2), intent(in) :: code_str
+    logical, intent(in) :: lhydrophilic
+    integer, intent(in), optional :: ibin
+    character(len=*), intent(in), optional :: optical_model_str
+
+    ! Score of the currently selected aerosol index, and the score of
+    ! the current one under consideration
+    integer :: score, current_score
+
+    ! Loop index for aerosol type
+    integer :: ja
+
+    ! Return value
+    integer :: get_index
+
+    ! Issue a warning if there is more than one equal match
+    logical :: is_ambiguous
+
+    real(jprb) :: hook_handle
+
+    if (lhook) call dr_hook('radiation_aerosol_optics_description:get_index',0,hook_handle)
+
+    ! Initial values
+    get_index = 0
+    score = 0
+    is_ambiguous = .false.
+
+    if (lhydrophilic) then
+      ! Loop over hydrophilic aerosol types
+      do ja = 1,size(this%bin_philic)
+        current_score = 0
+        if (to_string(this%code_philic(:,ja)) == code_str) then
+          ! Aerosol code matches
+          if (present(ibin) .and. this%bin_philic(ja) > 0) then
+            if (ibin > 0) then
+              if (ibin == this%bin_philic(ja)) then
+                ! Requested bin number matches
+                current_score = 4
+              else
+                ! Requested bin number does not match
+                current_score = -1
+              end if
+            else
+              ! Bin number is zero: no request
+              current_score = 2
+            end if
+          else
+            ! No bin number present
+            current_score = 2
+          end if
+          if (present(optical_model_str)) then
+            if (to_string(this%optical_model_philic(1:len(optical_model_str),ja)) &
+                 &  == optical_model_str) then
+              ! Requested optical model matches
+              if (current_score >= 0) then
+                current_score = current_score + 4
+              end if
+            else
+              ! Requested optical model does not match
+              current_score = -1
+            end if
+          else if (current_score >= 0) then
+            ! No requested optical model
+            current_score = current_score + 2
+          end if
+          if (current_score > 0 .and. this%is_preferred_philic(ja)) then
+            current_score = current_score + 1
+          end if
+          if (current_score > score) then
+            ! Better score than any existing aerosol type
+            get_index = -ja
+            score = current_score
+            is_ambiguous = .false.
+          else if (current_score > 0 .and. current_score == score) then
+            is_ambiguous = .true.
+          end if
+        end if
+      end do
+    else
+      ! Loop over hydrophobic aerosol types
+      do ja = 1,size(this%bin_phobic)
+        current_score = 0
+        if (to_string(this%code_phobic(:,ja)) == code_str) then
+          ! Aerosol code matches
+          if (present(ibin) .and. this%bin_phobic(ja) > 0) then
+            if (ibin > 0) then
+              if (ibin == this%bin_phobic(ja)) then
+                ! Requested bin number matches
+                current_score = 4
+              else
+                ! Requested bin number does not match
+                current_score = -1
+              end if
+            else
+              ! Bin number is zero: no request
+              current_score = 2
+            end if
+          else
+            ! No bin number requested or present
+            current_score = 2
+          end if
+          if (present(optical_model_str)) then
+            if (to_string(this%optical_model_phobic(1:len(optical_model_str),ja)) &
+                 &  == optical_model_str) then
+              ! Requested optical model matches
+              if (current_score >= 0) then
+                current_score = current_score + 4
+              end if
+            else
+              ! Requested optical model does not match
+              current_score = -1
+            end if
+          else if (current_score >= 0) then
+            ! No requested optical model
+            current_score = current_score + 2
+          end if
+          if (current_score > 0 .and. this%is_preferred_phobic(ja)) then
+            current_score = current_score + 1
+          end if
+          if (current_score > score) then
+            ! Better score than any existing aerosol type
+            get_index = ja
+            score = current_score
+            is_ambiguous = .false.
+          else if (current_score > 0 .and. current_score == score) then
+            is_ambiguous = .true.
+          end if          
+        end if
+      end do
+    end if
+
+    if (is_ambiguous) then
+      write(nulout,'(a,a2,a,l1,a)') 'Warning: get_index("', code_str, '",', lhydrophilic, &
+           &  ',...) does not unambiguously identify an aerosol optical property index'
+    end if
+
+    if (lhook) call dr_hook('radiation_aerosol_optics_description:get_index',1,hook_handle)
+
+  end function get_index
+
+  !---------------------------------------------------------------------
+  ! Utility function to convert an array of single characters to a
+  ! character string (yes Fortran's string handling is a bit rubbish)
+  pure function to_string(arr) result(str)
+    character, intent(in)  :: arr(:)
+    character(len=size(arr)) :: str
+    integer :: jc
+    do jc = 1,size(arr)
+      str(jc:jc) = arr(jc)
+    end do
+  end function to_string
+
+end module radiation_aerosol_optics_description
